package com.pms.ocp.biz;

import com.pms.ocp.model.dto.ModelPropertyVersionDemandDTO;
import com.pms.ocp.model.dto.ModelVersionDemandDTO;
import com.pms.ocp.model.entity.Model;
import com.pms.ocp.model.entity.ModelBaseVersion;
import com.pms.ocp.model.entity.ModelPropertyVersion;

import java.util.List;

/**
 * @Auther: wangjian
 * @Date: 2022/4/1 10:29
 * @Description:
 */
public interface BizModelRequirementService {

    /**
     * 创建模型需求
     *
     * @param modelVersionDemandDTO
     * @return
     */
    Integer createModelRequirement(ModelVersionDemandDTO modelVersionDemandDTO);


    /**
     * 创建模型属性
     *
     * @param modelPropertyVersionDemandDTO
     * @return
     */
    Integer createModelPropertyRequirement(ModelPropertyVersionDemandDTO modelPropertyVersionDemandDTO);

    /**
     * 修改模型需求
     *
     * @param modelVersionDemandDTO
     * @return
     */
    Integer updateModelRequirement(ModelVersionDemandDTO modelVersionDemandDTO);

    /**
     * 修改模型属性需求
     *
     * @param modelPropertyVersionDemandDTO
     * @return
     */
    Integer updateModelPropertyRequirement(ModelPropertyVersionDemandDTO modelPropertyVersionDemandDTO);

    /**
     * 删除模型需求
     *
     * @param demandId
     * @param modelId
     * @return
     */
    Integer deleteModelRequirement(String demandId, String modelId);

    /**
     * 删除模型属性需求
     *
     * @param demandId
     * @param modelId
     * @param proId
     * @return
     */
    Integer deleteModelPropertyRequirement(String demandId, String modelId, String proId);

    /**
     * 获取模型需求
     *
     * @param
     * @return
     */
    List<ModelBaseVersion> getModelRequirementList(String modelCode, String modelGroupCode, int currentPage, int pageSize);

    /**
     * 获取模型属性需求
     *
     * @param
     * @return
     */
    List<ModelPropertyVersion> getModelPropertyRequirementList(String propId, String modelCode, int currentPage, int pageSize);

    /**
     * 获取模型需求
     *
     * @param objId
     * @param modelGroupCode
     * @return
     */
    Model getModelRequirement(String objId, String modelGroupCode);

    /**
     * 获取模型属性需求
     *
     * @param objId
     * @param modelGroupCode
     * @return
     */
    Model getModelPropertyRequirement(String objId, String modelGroupCode);

}
