package com.pms.ocp.service;

import com.pms.ocp.model.entity.ModelRequirement;

import java.util.List;

/**
 * @Auther: wangjian
 * @Date: 2022/3/29 17:43
 * @Description:模型需求业务层接口
 */
public interface ModelDemandService {

    /**
     * 创建模型需求
     *
     * @param modelRequirement
     * @return
     */
    Integer createModelDemand(ModelRequirement modelRequirement);

    /**
     * 删除模型需求
     *
     * @param objId
     * @param requirementCode
     * @return
     */
    Integer deleteModelDemand(String objId, String requirementCode);

    /**
     * 更新模型需求
     *
     * @param modelRequirement
     * @return
     */
    Integer updateModelDemand(ModelRequirement modelRequirement);

    /**
     * 获取模型需求
     *
     * @param
     * @return
     */
    List<ModelRequirement> getModelDemandList(List<String> modelIds);

    /**
     * 获取模型需求列表
     *
     * @param objId
     * @param modelCode
     * @return
     */
    ModelRequirement getModelDemand(String objId, String modelCode);

}
