package com.pms.ocp.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.pms.ocp.mapper.ModelRequirementMapper;
import com.pms.ocp.model.entity.ModelRequirement;
import com.pms.ocp.service.ModelDemandService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Auther: wangjian
 * @Date: 2022/3/29 17:43
 * @Description:模型需求业务层接口实现
 */

@Service
public class ModelDemandServiceImpl implements ModelDemandService {

    @Autowired
    private ModelRequirementMapper modelRequirementMapper;

    @Override
    public Integer createModelDemand(ModelRequirement modelRequirement) {
        return modelRequirementMapper.insert(modelRequirement);
    }

    @Override
    public Integer deleteModelDemand(String objId, String requirementCode) {
        QueryWrapper<ModelRequirement> queryWrapper = new QueryWrapper();

        if (StringUtils.isNotEmpty(objId)) {
            queryWrapper.lambda().eq(ModelRequirement::getObjId, objId);
        }

        if (StringUtils.isNotEmpty(requirementCode)) {
            queryWrapper.lambda().eq(ModelRequirement::getRequirementCode, requirementCode);
        }

        return modelRequirementMapper.delete(queryWrapper);
    }

    @Override
    public Integer updateModelDemand(ModelRequirement modelRequirement) {
        UpdateWrapper<ModelRequirement> updateWrapper = new UpdateWrapper<>();

        updateWrapper.lambda().eq(ModelRequirement::getRequirementCode, modelRequirement.getRequirementCode());

        return modelRequirementMapper.update(modelRequirement, updateWrapper);
    }

    @Override
    public List<ModelRequirement> getModelDemandList(List<String> modelIds) {

        QueryWrapper<ModelRequirement> wrapper = new QueryWrapper<>();

        if (!modelIds.isEmpty()) {
            wrapper.lambda().in(ModelRequirement::getRequirementCode, modelIds);
        }

        return modelRequirementMapper.selectList(wrapper);
    }

    @Override
    public ModelRequirement getModelDemand(String objId, String modelCode) {
        return null;
    }
}
